Foreman - Refactor #27906

Use modern Facter 3 facts
09/23/2019 12:36 PM - Ewoud Kohl van Wijngaarden

Status: Closed
Priority: Normal
Assignee: Ewoud Kohl van Wijngaarden
Category: Facts
Target version:
Difficulty: Fixed in Releases: 3.2.0
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/7059,
https://github.com/theforeman/foreman/p
https://github.com/theforeman/foreman/p
ull/8450
Description

Currently we still rely on various Facter 2 facts that are deprecated in Facter 3 and will be removed in Facter 4.

https://puppet.com/docs/facter/3.11/core_facts.html#legacy-facts is a list of legacy facts.

Related issues:

Related to Foreman - Refactor #32130: Drop support of Facter 2 facts Duplicate
Related to Foreman - Feature #32337: Drop support for Facter versions older t... Ready For Testing
Related to Foreman - Refactor #32345: Provide non-DB model methods and deprec... New

Associated revisions

Revision 50a336d5 - 10/14/2019 02:58 PM - Ewoud Kohl van Wijngaarden
Refs #27906 - Clean up PuppetFactParser (#7059)

As a preparation to moving to modern facts, this refactor cleans up the
operatingsystem method to make a future refactor easier.

Revision cc4a95ff - 11/16/2021 01:24 PM - Ewoud Kohl van Wijngaarden
Fixes #27906 - Always prefer modern facts in Facter
Facter started to introduce structured facts in Facter 2. Since Facter

3, the old facts are deprecated. This introduces helper methods to
provide the abstraction and always prefers modern facts.

It does make a change that it no longer considers the Isbdistrelease

fact. 5d61c18fa7bdee314ac146babb35353c16c63b37 already preferred the
os.release.full fact which is present with Facter 2.2 or newer. It

should also fall back to the operatingsystemrelease fact which is

present since Facter 1.5 and a more reliable fact.

To make things easier, it annotates which for each fact which version of
Facter introduced it.

Revision e98fc011 - 11/16/2021 01:24 PM - Ewoud Kohl van Wijngaarden
Refs #27906 - Add FacterDB test

It should be noted that these tests are fairly slow. On my system they
add a minute of runtime to the tests.

History

#1 - 09/23/2019 12:38 PM - The Foreman Bot
https://puppet.com/docs/facter/3.11/core_facts.html#legacy-facts

- Status changed from New to Ready For Testing
- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/foreman/pull/7059 added

#2 - 03/19/2021 10:54 AM - Ewoud Kohl van Wijngaarden
- Related to Refactor #32130: Drop support of Facter 2 facts added

#3 - 03/29/2021 01:11 PM - Ewoud Kohl van Wijngaarden
- Status changed from Ready For Testing to New
- Assignee deleted (Ewoud Kohl van Wijngaarden)

#4 - 03/29/2021 01:12 PM - Ewoud Kohl van Wijngaarden

It should also be noted that Facter 4 ended up keeping the legacy facts. However, we should still update to the modern facts so at some point legacy
facts can be turned off.

#5 - 04/09/2021 08:04 AM - Marek Hulan
from the other issue:

Today we still support so called legacy facts in places we parse puppet facts. The drop of the Facter 2 was announced a while ago at
https://community.theforeman.org/t/the-road-to-making-puppet-optional/17983 and Foreman 2.6/3.0 would be a good time to clean up this code

While some work has been done, there are still facter 2 facts supported, they should be removed from the codebase.

#6 - 04/14/2021 06:04 AM - Lukas Zapletal

Guys, are we sure about dropping facter 2.x from the codebase? There was a 2.4 user complaining about 2.x facter broken after upgrade, | think we
might still have some users. And this should probably be communicated in advance, we haven't announced or deprecated anything yet IIRC.

https://community.theforeman.org/t/puppet-fact-parser-is-failing-with-string-does-not-have-dig-method/23138

From discovery standpoint we are now good, it took me a while to upgrade to f4 but we are good. But honestly | think we should actually do the very
opposite - fix f2 support, then do some announcement and deprecation warnings and schedule this to 3.1 or something like that.

#7 - 04/14/2021 11:52 AM - Ewoud Kohl van Wijngaarden

IMHO we should make sure the codebase 100% works when no legacy facts are present. That will be a first step to deprecation.

The particular case mentioned doesn't appear to be related. The structured os fact should be present in 2.4 already.

#8 - 04/15/2021 07:41 AM - Lukas Zapletal

While | agree, | think we should keep the status-quo for some time before we are ready for the switch. | suggest that we explore what exactly is
wrong, since this was broken quite recently (the user reports 2.4) chances are we can fix that easily and buy some more time.

#9 - 04/15/2021 09:27 AM - Ewoud Kohl van Wijngaarden

In the linked post | have said that it should work if the user doesn't use stringify_facts = true. In Puppet 4 that setting has been removed and is always
false. We have also dropped support for Puppet < 5 so it would be weird to document "this is how you make unsupported software work". Also note
that the user reported they upgraded to 1.24 which is also unsupported.

What we can do is more graceful error handling. IMHO this isn't very helpful to a user. I'm thinking about adding abstractions for all facts with rescue
statements everywhere that says "failed to read fact x" so it's at least easier to understand.

#10 - 04/16/2021 08:36 AM - Marek Hulan

Not a bad idea about improving the error reporting, Ewoud could you turn that into a new RM issue and describe the expected behavior on several
examples please? Like if uploaded facts does not contain fact xyz, he should see an error saying "fact xyz is not present". Ideally also specify where
(notification drawer, log, API response, host status or something else)

| agree we should go ahead and drop support for legacy facts, | asked few users in our community and there was no concern with that. People seem
to be upgrading their Puppet infrastructure (good). If they have older facters deployed, they probably also have older Foreman installed.

#11 - 04/16/2021 10:59 AM - Ewoud Kohl van Wijngaarden

https://github.com/puppetlabs/facter/commit/58901c0101e8c8d7f1ec80bcb9356e61d7cadeed did add a schema of facts. Its history can be used as a
source of when a fact was introduced. That's the best way right now that | know to determine it.

#12 - 04/16/2021 11:34 AM - The Foreman Bot
- Status changed from New to Ready For Testing
https://community.theforeman.org/t/the-road-to-making-puppet-optional/17983
https://community.theforeman.org/t/puppet-fact-parser-is-failing-with-string-does-not-have-dig-method/23138
- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/foreman/pull/8449 added

#13 - 04/16/2021 01:05 PM - Ewoud Kohl van Wijngaarden
- Related to Feature #32337: Drop support for Facter versions older than 2.2 added

#14 - 04/16/2021 01:08 PM - Ewoud Kohl van Wijngaarden
- Category deleted (Facts)
- Assignee deleted (Ewoud Kohl van Wijngaarden)

In the attached PR | updated all facts to their modern version where possible. | also annotated all facts and when they were introduced. It looks like if
we raise the version to at least 2.2, we can simplify the parser so | opened #32337 for that.

Let's keep the scope of this PR to only make sure we can operate without any legacy facts present.

#15 - 04/16/2021 02:52 PM - The Foreman Bot

- Assignee set to Ewoud Kohl van Wijngaarden

#16 - 04/19/2021 10:51 AM - Ewoud Kohl van Wijngaarden
- Related to Refactor #32345: Provide non-DB model methods and deprecate DB model methods in FactParser added

#17 - 11/10/2021 11:06 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/8450 added

#18 - 11/16/2021 01:24 PM - The Foreman Bot
- Fixed in Releases 3.2.0 added

#19 - 11/16/2021 02:01 PM - Ewoud Kohl van Wijngaarden
- Status changed from Ready For Testing to Closed

Applied in changeset foreman|cc4a95ffbe24ddc1bc16dd3f13ceef2a74233119.

#20 - 02/15/2022 01:31 PM - Amit Upadhye

- Category set to Facts
